<template>
  <div class="bg">
    <Card class="form-container">
      <p
        class="error"
        v-if="error">
        {{ error }}
      </p>
      <p v-else>&nbsp;</p>

      <div class="form-group">
        <input
          type="text"
          placeholder="Name"
          class="form-input"
          v-model="name" />
        <input
          type="email"
          placeholder="Email"
          class="form-input"
          v-model="email" />
        <input
          type="password"
          placeholder="Password"
          class="form-input"
          v-model="password" />
        <input
          type="password"
          placeholder="Password confirmation"
          class="form-input"
          v-model="passwordConfirmation" />
      </div>
  
      <Button text="Cadastrar" @click.native="submit"/>
    </Card>
  </div>
</template>

<script>
import gql from 'graphql-tag';
import Button from '@/components/Button.vue';
import Card from '@/components/Card.vue';

export default {
  components: {
    Button,
    Card
  },

  data() {
    return {
      name: '',
      email: '',
      password: '',
      passwordConfirmation: '',
      error: null,
    };
  },

  methods: {
    validate() {
      if (!this.name) {
        this.error = "Nome é obrigatório";
        return false;
      }

      if (!this.email) {
        this.error = "Email é obrigatório";
        return false;
      } 
      else {
        const rgx = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (!rgx.test(this.email)) {
          this.error = "Email deve ser válido";
          return false;
        }
      }

      if (!this.password) {
        this.error = "Senha é obrigatória";
        return false;
      }

      if (this.password != this.passwordConfirmation) {
        this.error = "Senhas devem ser iguais";
        return false;
      }

      return true;
    },
    async submit() {
      this.errors = [];
      if (!this.validate()) return;

      const signupMutation = gql`
        mutation signupMutation(
          $name: String!
          $email: String!
          $password: String!
          $passwordConfirmation: String!
        ) {
          signup(
            name: $name
            email: $email
            password: $password
            passwordConfirmation: $passwordConfirmation
          ) {
            id
          }
        }
      `;

      const response = await this.$apollo.mutate({
        mutation: signupMutation,
        variables: {
          name: this.name,
          email: this.email,
          password: this.password,
          passwordConfirmation: this.passwordConfirmation,
        },
        errorPolicy: 'all',
      });

      if (!response.data) this.error = response.errors.map(e => el.message);
      else this.$router.history.push('/login');
    },
  },
};
</script>

<style lang="postcss" scoped>
.bg {
  background-color: #6A5ACE;
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 60vh;
}

.form-container {
  grid-area: card;
  display: flex;
  flex-flow: column nowrap;

  justify-content: space-around;
  align-items: center;
  min-height: 50vh;
}

.error {
  color: black;
}

.form-group {
  display: flex;
  flex-flow: column nowrap;
}

.form-input {
  margin: 0.75em;
  background-color: lightgray;
  color: #212121;
  padding: 0.5em;
  border-radius: 5px;
}

</style>
